#ifndef _CORPUS_H
#define _CORPUS_H

#define OFFSET 0                  // offset for reading data
#define OFFSET_LABEL 0

typedef struct
{
	int gndlabel;	// the ground truth response variable value
	int gndlabel_bk;
	int predlabel;	// the predicted response variable value
	double predscore; // the prediction score
	double lhood;
	int* words;
    int length;
} Document;


class Corpus
{
public:
	Corpus(void);
	~Corpus(void);

	void read_data_binary(char* data_filename, int refLabel = -1);
	// if any word id >= OOV, it means that this word is Out Of Vocabulary.
	void read_data_oov(char* data_filename, const int OOV, int refLabel = -1); 
	void print(char* o_file);
	void shuffle();
	Corpus* get_traindata(const int nfold, const int foldix);
	Corpus* get_testdata(const int nfold, const int foldix);

public:
   Document* docs;
   int num_docs;
   int num_terms;

};

#endif
