#ifndef _PARAMS_H
#define _PARAMS_H

class Params
{
public:
	Params(void);
public:
	~Params(void);

	void read_settings(char* filename);

public:
	int EM_MAX_ITER;
	double EM_CONVERGED;
	int NITERS; // number of GibbsMedLDA sampling iterations to getto the stationary status
	double GIBBS_CONVERGED;
	int SAMPLING_LAG;

	int BURN_IN;
	int MAX_SAMPLES;

	double INITIAL_C;
	double INITIAL_NUSQINV;
	double INITIAL_ALPHA;
	double INITIAL_BETA;
	double DELTA_ELL;

	int ITER_SAVE_STEP; // save the model per ITER_SAVE_STEP steps
	int SAVE_TOP_WORDS;

	int NTOPICS;
	int NLABELS;

	char *train_filename;   // the file names of training;
	char *test_filename;
	char *mapper_filename;
	char *model_filename;
	char *res_filename;

	int NFOLDS;
	char *dir; // dir in which the results and some temp results will stored.

	bool INNER_CV_C;
	int INNER_FOLDNUM_C;
	int CV_PARAMNUM_C;
	double* cv_param_vec_C;

	bool INNER_CV_ALPHA;
	int INNER_FOLDNUM_ALPHA;
	int CV_PARAMNUM_ALPHA;
	double* cv_param_vec_ALPHA;

public:
	Params* copy();
};

#endif
