#ifndef _UTILS_H
#define _UTILS_H

#include <stdio.h>
#include <math.h>
#include <float.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>

#define MY_M_PI 3.141592653589793238462643

double get_runtime(void);
void make_directory(char* name);

double log_sum(double log_a, double log_b);
double log_sum(double* log_x, int n);
double lgamma(double x);
double max(double* x, int n);
int argmax(double* x, int n);
double dotprod(double *a, double *b, const int&n);
void printmatrix(double **A, double n);

void matrixprod(double *a, double **A, double *res, const int&n);
void matrixprod(double **A, double *a, double *res, const int&n);
void addmatrix(double **A, double *a, double *b, const int &n, double factor);
void addmatrix2(double **A, double *a, double *b, const int &n, double factor);
void addvec(double *res, double *a, const int &n, double factor);
void addvec(double *res, double *a, const int &n);

bool inverse(double **A, double **res, const int &n);
double inverse_det(double **A, double **res, const int &n);
bool choleskydec(double **A, double **res, const int &n, bool isupper);
void inverse_cholydec(double **A, double **res, double **lowerTriangle, const int &n);

double compute_mean_var(double &dMean, double *arr, const int &n);

#endif
